#ifndef TOKENIZER_H__
#define TOKENIZER_H__

#include <string>  // string
#include <utility> // pair

class tokenizer {
public:
  typedef std::pair<std::string::size_type,std::string::size_type> range_type;
  // RXgN^: ؂蕶̏Wɗ^
  explicit tokenizer(const std::string& delimiter);
  // ^̃g[NJn
  void start(const std::string& source);
  // startɗ^̃g[NŏȂ
  void reset();
  // g[N؂oB؂og[NȂfalseԂ
  bool next();
  // nextŐ؂oꂽg[NԂ
  std::string token() const;
  // next؂oꂽg[N̈ʒuƒԂ
  range_type range() const;
private:
  std::string source_; // ΏۂƂȂ镶
  std::string delim_;  // ؂蕶̏W
  range_type range_;   // g[N̈ʒuƒ
};

#endif
