//  C DLL t@CłB

#include "stdafx.h"

#include "tokenizerTest.h"

#define zero safe_cast<Object^>(0)

void tokenizerTest::O() {
  t_ = new tokenizer(",!");
}

void tokenizerTest::n() {
  delete t_;
} 

void tokenizerTest::RXgNg() {
  Expect(t_->range().first, EqualTo(zero));
}

void tokenizerTest::g[NЂƂ؂o() {
  bool found;
  t_->start("hello,world");
  found = t_->next();
  Expect(found);
  Expect(t_->range().first, EqualTo(zero));
  Expect(t_->range().second, EqualTo(5));
  String^ result = str(t_->token());
  Expect(result, EqualTo("hello"));
}

void tokenizerTest::g[Nӂ؂o() {
  bool found;
  t_->start("hello,world");
  found = t_->next();
  Expect(found);
  found = t_->next();
  Expect(found);
  Expect(t_->range().first, EqualTo(6));
  Expect(t_->range().second, EqualTo(5));
  String^ result = str(t_->token());
  Expect(result, Is::EqualTo("world"));

  found = t_->next();
  Expect(!found);
}

void tokenizerTest::󕶎ɑ΂() {
  bool found;
  t_->start("");
  found = t_->next();
  Expect(!found);
}

void tokenizerTest::f~^̂Ȃꍇ() {
  bool found;
  t_->start("hello");
  found = t_->next();
  String^ result = str(t_->token());
  Expect(result, Is::EqualTo("hello"));
}

void tokenizerTest::f~^̏ꍇ() {
  bool found;
  t_->start(",,,");
  found = t_->next();
  Expect(!found);
}

void tokenizerTest::f~^Ŏn܂Iꍇ() {
  bool found;
  t_->start(",hello,");
  found = t_->next();
  String^ result = str(t_->token());
  Expect(result, Is::EqualTo("hello"));
  found = t_->next();
  Expect(!found);
}

void tokenizerTest::f~^̘A() {
  bool found;
  String^ result;
  t_->start(",hello,,world");
  found = t_->next();
  result = str(t_->token());
  Expect(result, Is::EqualTo("hello"));
  found = t_->next();
  result = str(t_->token());
  Expect(result, Is::EqualTo("world"));
  found = t_->next();
  Expect(!found);
}

void tokenizerTest::̃f~^() {
  bool found;
  String^ result;
  t_->start("!hello,!world!");
  found = t_->next();
  result = str(t_->token());
  Expect(result, Is::EqualTo("hello"));
  found = t_->next();
  result = str(t_->token());
  Expect(result, Is::EqualTo("world"));
  found = t_->next();
  Expect(!found);
}

