#pragma once

using namespace System;
using namespace NUnit::Framework;
using namespace NUnit::Framework::SyntaxHelpers;

#include "tokenizer.h"

[TestFixture]
public ref class tokenizerTest : AssertionHelper {
private:
  tokenizer* t_;
  static String^ str(const std::string& s) { return gcnew String(s.c_str()); }
public:
  [SetUp]    void O();
  [TearDown] void n();

  [Test] void RXgNg();
  [Test] void g[NЂƂ؂o(); 
  [Test] void g[Nӂ؂o(); 
  [Test] void 󕶎ɑ΂();
  [Test] void f~^̂Ȃꍇ(); 
  [Test] void f~^̏ꍇ(); 
  [Test] void f~^Ŏn܂Iꍇ(); 
  [Test] void f~^̘A();
  [Test] void ̃f~^();
};
